"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.TreeButton = void 0;
var _react = require("react");
var _testable = require("@instructure/ui-testable/lib/testable.js");
var _Img = require("@instructure/ui-img/lib/Img");
var _callRenderProp = require("@instructure/ui-react-utils/lib/callRenderProp.js");
var _emotion = require("@instructure/emotion");
var _styles = _interopRequireDefault(require("./styles"));
var _theme = _interopRequireDefault(require("./theme"));
var _props = require("./props");
var _jsxRuntime = require("@emotion/react/jsx-runtime");
var _dec, _dec2, _class, _TreeButton;
/*
 * The MIT License (MIT)
 *
 * Copyright (c) 2015 - present Instructure, Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
// Todo: merge TreeButton and TreeNode: TreeButton should be a special type of TreeNode
/**
---
parent: TreeBrowser
id: TreeBrowser.Button
---
**/
let TreeButton = exports.TreeButton = (_dec = (0, _emotion.withStyle)(_styles.default, _theme.default), _dec2 = (0, _testable.testable)(), _dec(_class = _dec2(_class = (_TreeButton = class TreeButton extends _react.Component {
  constructor(...args) {
    super(...args);
    this.ref = null;
    this.handleRef = el => {
      if (el && typeof this.props.containerRef === 'function') {
        this.props.containerRef(el.parentElement);
      }
      this.ref = el;
    };
  }
  componentDidMount() {
    var _this$props$makeStyle, _this$props;
    (_this$props$makeStyle = (_this$props = this.props).makeStyles) === null || _this$props$makeStyle === void 0 ? void 0 : _this$props$makeStyle.call(_this$props);
  }
  componentDidUpdate() {
    var _this$props$makeStyle2, _this$props2;
    (_this$props$makeStyle2 = (_this$props2 = this.props).makeStyles) === null || _this$props$makeStyle2 === void 0 ? void 0 : _this$props$makeStyle2.call(_this$props2);
  }
  defaultContentRenderer(props) {
    const name = props.name,
      descriptor = props.descriptor,
      styles = props.styles;
    return (0, _jsxRuntime.jsxs)("span", {
      css: styles.layout,
      children: [this.renderImage(), (0, _jsxRuntime.jsxs)("span", {
        css: styles.text,
        children: [(0, _jsxRuntime.jsx)("span", {
          css: styles.textName,
          children: name
        }), descriptor ? (0, _jsxRuntime.jsx)("span", {
          css: styles.textDescriptor,
          title: descriptor,
          children: descriptor
        }) : null]
      })]
    });
  }
  renderImage() {
    const type = this.props.type;
    switch (type) {
      case 'collection':
        return this.renderCollectionIcon();
      case 'item':
        return this.renderItemImage();
      default:
        break;
    }
    return void 0;
  }
  renderCollectionIcon() {
    const _this$props3 = this.props,
      expanded = _this$props3.expanded,
      collectionIcon = _this$props3.collectionIcon,
      collectionIconExpanded = _this$props3.collectionIconExpanded,
      styles = _this$props3.styles;
    if (collectionIcon || collectionIconExpanded) {
      return (0, _jsxRuntime.jsx)("div", {
        css: styles === null || styles === void 0 ? void 0 : styles.icon,
        children: (0, _callRenderProp.callRenderProp)(expanded ? collectionIconExpanded : collectionIcon)
      });
    }
    return void 0;
  }
  renderItemImage() {
    const _this$props4 = this.props,
      thumbnail = _this$props4.thumbnail,
      itemIcon = _this$props4.itemIcon,
      styles = _this$props4.styles;
    if (thumbnail) {
      return (0, _jsxRuntime.jsx)("div", {
        css: styles === null || styles === void 0 ? void 0 : styles.thumbnail,
        children: (0, _jsxRuntime.jsx)(_Img.Img, {
          src: thumbnail,
          constrain: "cover",
          alt: ""
        })
      });
    }
    if (itemIcon) {
      return (0, _jsxRuntime.jsx)("div", {
        css: styles === null || styles === void 0 ? void 0 : styles.icon,
        children: (0, _callRenderProp.callRenderProp)(itemIcon)
      });
    }
    return void 0;
  }
  render() {
    const _this$props5 = this.props,
      styles = _this$props5.styles,
      renderContent = _this$props5.renderContent;
    const buttonContent = renderContent ? renderContent(this.props) : this.defaultContentRenderer(this.props);
    // VoiceOver can't navigate without the buttons, even though they don't do anything
    return (0, _jsxRuntime.jsx)("button", {
      ref: this.handleRef,
      tabIndex: -1,
      type: "button",
      css: styles === null || styles === void 0 ? void 0 : styles.treeButton,
      children: buttonContent
    });
  }
}, _TreeButton.displayName = "TreeButton", _TreeButton.componentId = 'TreeBrowser.Button', _TreeButton.allowedProps = _props.allowedProps, _TreeButton.propTypes = _props.propTypes, _TreeButton.defaultProps = {
  type: 'treeButton',
  size: 'medium',
  variant: 'folderTree',
  selected: false,
  focused: false,
  expanded: false
}, _TreeButton)) || _class) || _class);
var _default = exports.default = TreeButton;