"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.propTypes = exports.allowedProps = void 0;
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Children = require("@instructure/ui-prop-types/lib/Children.js");
var _TreeNode = require("../TreeNode");
/*
 * The MIT License (MIT)
 *
 * Copyright (c) 2015 - present Instructure, Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

const propTypes = exports.propTypes = {
  id: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  name: _propTypes.default.string,
  descriptor: _propTypes.default.string,
  items: _propTypes.default.array,
  collections: _propTypes.default.array,
  expanded: _propTypes.default.bool,
  selection: _propTypes.default.string,
  size: _propTypes.default.oneOf(['small', 'medium', 'large']),
  variant: _propTypes.default.oneOf(['folderTree', 'indent']),
  collectionIcon: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  collectionIconExpanded: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  itemIcon: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  getItemProps: _propTypes.default.func,
  getCollectionProps: _propTypes.default.func,
  onItemClick: _propTypes.default.func,
  onCollectionClick: _propTypes.default.func,
  onKeyDown: _propTypes.default.func,
  numChildren: _propTypes.default.number,
  level: _propTypes.default.number.isRequired,
  position: _propTypes.default.number,
  renderBeforeItems: _Children.Children.oneOf([_TreeNode.TreeNode]),
  renderAfterItems: _Children.Children.oneOf([_TreeNode.TreeNode]),
  containerRef: _propTypes.default.func,
  isCollectionFlattened: _propTypes.default.bool,
  renderContent: _propTypes.default.func,
  compareFunc: _propTypes.default.func
};
const allowedProps = exports.allowedProps = ['id', 'name', 'descriptor', 'items', 'collections', 'expanded', 'selection', 'size', 'variant', 'collectionIcon', 'collectionIconExpanded', 'itemIcon', 'getItemProps', 'getCollectionProps', 'onItemClick', 'onCollectionClick', 'onKeyDown', 'numChildren', 'level', 'position', 'renderBeforeItems', 'renderAfterItems', 'containerRef', 'isCollectionFlattened', 'renderContent'];