"use strict";

var _react = require("@testing-library/react");
var _vitest = require("vitest");
require("@testing-library/jest-dom");
var _index = require("../index");
var _jsxRuntime = require("@emotion/react/jsx-runtime");
var _TreeNode, _button;
/*
 * The MIT License (MIT)
 *
 * Copyright (c) 2021 - present Instructure, Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
describe('<TreeNode />', () => {
  it('should render children', async () => {
    (0, _react.render)(_TreeNode || (_TreeNode = (0, _jsxRuntime.jsx)(_index.TreeNode, {
      children: (0, _jsxRuntime.jsx)("button", {
        children: "Hello World"
      })
    })));
    const item = _react.screen.getByText('Hello World');
    expect(item).toBeInTheDocument();
  });
  it('supports containerRef prop', async () => {
    const containerRef = _vitest.vi.fn();
    (0, _react.render)((0, _jsxRuntime.jsx)("div", {
      "data-testid": "1",
      children: (0, _jsxRuntime.jsx)(_index.TreeNode, {
        containerRef: containerRef,
        children: _button || (_button = (0, _jsxRuntime.jsx)("button", {
          children: "Hello World"
        }))
      })
    }));
    const div = _react.screen.getByTestId('1');
    expect(containerRef).toHaveBeenCalledWith(div);
  });
});