import React from 'react';
import type { WithStyleProps, ComponentStyle } from '@instructure/emotion';
import type { PropValidators, TreeBrowserButtonTheme } from '@instructure/shared-types';
import type { TreeBrowserCommonProps } from '../props';
type TreeBrowserButtonOwnProps = {
    id?: string | number;
    name?: string;
    descriptor?: string;
    type?: 'collection' | 'item' | string;
    thumbnail?: string;
    /**
     * Called when this button is clicked
     */
    onClick?: (e: React.MouseEvent) => void;
    expanded?: boolean;
    selected?: boolean;
    focused?: boolean;
    level?: number;
    /**
     * A function that returns a reference to the parent li element
     */
    containerRef?: (el: HTMLElement | null) => void;
} & TreeBrowserCommonProps;
type PropKeys = keyof TreeBrowserButtonOwnProps;
type AllowedPropKeys = Readonly<Array<PropKeys>>;
type TreeBrowserButtonProps = TreeBrowserButtonOwnProps & WithStyleProps<TreeBrowserButtonTheme, TreeBrowserButtonStyle>;
type TreeBrowserButtonStyle = ComponentStyle<'treeButton' | 'layout' | 'text' | 'textName' | 'textDescriptor' | 'icon' | 'thumbnail' | 'node'>;
declare const propTypes: PropValidators<PropKeys>;
declare const allowedProps: AllowedPropKeys;
export type { TreeBrowserButtonProps, TreeBrowserButtonStyle };
export { propTypes, allowedProps };
//# sourceMappingURL=props.d.ts.map