import React from 'react';
import type { CollectionData } from '../props';
import type { PropValidators, TreeBrowserCollectionTheme } from '@instructure/shared-types';
import type { WithStyleProps, ComponentStyle } from '@instructure/emotion';
import { CollectionProps, TreeBrowserBaseProps } from '../props';
type TreeBrowserCollectionOwnProps = {
    level: number;
    onKeyDown?: (e: React.KeyboardEvent, data: CollectionData) => void;
    onItemClick?: (e: React.MouseEvent, data: CollectionData) => void;
    numChildren?: number;
    position?: number;
    selection?: string;
} & CollectionProps & TreeBrowserBaseProps;
type PropKeys = keyof TreeBrowserCollectionOwnProps;
type AllowedPropKeys = Readonly<Array<PropKeys>>;
type TreeBrowserCollectionProps = TreeBrowserCollectionOwnProps & WithStyleProps<TreeBrowserCollectionTheme, TreeBrowserCollectionStyle>;
type TreeBrowserCollectionStyle = ComponentStyle<'treeCollection' | 'list' | 'item'>;
declare const propTypes: PropValidators<PropKeys>;
declare const allowedProps: AllowedPropKeys;
type TreeCollectionState = {
    focused: string;
};
export type { TreeBrowserCollectionProps, TreeBrowserCollectionStyle, TreeCollectionState };
export { propTypes, allowedProps };
//# sourceMappingURL=props.d.ts.map