import React from 'react';
import type { PropValidators, TreeBrowserButtonTheme } from '@instructure/shared-types';
import type { WithStyleProps } from '@instructure/emotion';
import type { TreeBrowserButtonProps, TreeBrowserButtonStyle } from '../TreeButton/props';
import { CollectionData } from '../props';
type TreeBrowserNodeOwnProps = Pick<TreeBrowserButtonProps, 'id' | 'size' | 'variant' | 'selected' | 'focused' | 'itemIcon' | 'thumbnail' | 'level' | 'containerRef' | 'onClick'> & {
    onKeyDown?: (e: React.KeyboardEvent, data: CollectionData) => void;
    /**
     * The children to be rendered within the `<TreeNode />`
     */
    children?: React.ReactNode;
};
type PropKeys = keyof TreeBrowserNodeOwnProps;
type AllowedPropKeys = Readonly<Array<PropKeys>>;
type TreeBrowserNodeProps = TreeBrowserNodeOwnProps & WithStyleProps<TreeBrowserButtonTheme, TreeBrowserButtonStyle>;
declare const propTypes: PropValidators<PropKeys>;
declare const allowedProps: AllowedPropKeys;
export type { TreeBrowserNodeProps };
export { propTypes, allowedProps };
//# sourceMappingURL=props.d.ts.map